import { ElementRef, EventEmitter, NgZone, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Subject } from 'rxjs';
import { AbmConfig } from './abm.config';
import { LoaderService } from './loader.service';
import * as i0 from "@angular/core";
export declare abstract class AbmBaseComponent implements OnInit, OnChanges, OnDestroy {
    protected el: ElementRef<HTMLElement>;
    protected COG: AbmConfig;
    protected zone: NgZone;
    protected loader: LoaderService;
    protected destroy$: Subject<void>;
    options: any;
    ready: EventEmitter<any>;
    protected map: any;
    config: AbmConfig;
    abstract defaultOptions(): any;
    abstract create(): void;
    abstract destroy(): void;
    constructor(el: ElementRef<HTMLElement>, COG: AbmConfig, zone: NgZone, loader: LoaderService);
    private _updateOptions;
    private _initMap;
    private _getSrc;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AbmBaseComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AbmBaseComponent, never, never, { "options": "options"; }, { "ready": "ready"; }, never>;
}
